unit Unit1;
//sozikrypt-Quelltext.    (V1.7)
//(c) dr.chr.-heinrich wunderlich und michael krieg 19.6.-2.7.1998

// ein programm zum codieren und decodieren von Daten
// allgemeines:
// der Codieralgorithmus III:
// Der Algorithmus besteht aus zwei Teilen: einem Positionswechsel und einem Zufallszahlen-Additionsalgorithums
//
// Der Positionswechselalgorithmus
//
// Der zu Codierende Text (Quelltext) wird in eine rechteckige Matrix eingelesen. Die Matrix hat die Breite (Int(Wurzel(Textlnge)
// Die Hhe der Matrix ist mindestens Int(wurzel(Textlnge))(+ 1, wenn Rest).
// von der Hhe wird etwas abgezogen, je nach Wert des gerade aktuellen Codewortzeichens
// Die Breite ist int(Textlnge+Hhe)
// Rest=Textlnge-Hhe mal Breite
// Der zu codierende Text wird in Zeilen in die Matrix eingelesen, und in Spalten wieder ausgelesen. Die Spalten werden aneinandergehngt und ergeben einen schon zerrissenen Text.
// Schon dadurch kommt etwas "Chaos" in die Buchstaben.
// Dann werden die erhaltenen Spalten je um den Betrag des ersten Buchstaben des Codewortes gegeneinander rotiert, dh. abwechseln eine Spalte rechtsrum und eine linksrum.
// Dann werden die Spalten wieder zu einem Text aneinandergehngt.
// Dann macht man die gleiche Zeilen/Spaltenwechsel-Prozedur nochmal, und verschiebt das Ergebnis um den Wert des nchsten Buchstabens des Codewortes.....
// sind alle Buchstaben des Codewortes abgearbeitet, ist der Positionswechselalgorithmus beendet.
//
//Der Zufallszahlenalgorithmus
//
//1) Die ersten vier Ziffern des Pawortes werden addiert und 1 hinzugezhlt.
// Die erhaltene Summe wird um 256 rotiert, dh. Summe mod 256 gebildet.
// Der erhaltene Wert ist x.
//2) aus der gesamten Zeichenkette (d.H. des Masterstrings, der mit dem Paword beginnt und an den langsam immer mehr Zufallszahlen angehngt werden)
// werden in gleichen Abstnden n (N= Lnge des Pawords) Zeichen entnommen. Deren Checksumme ergibt Y.
//3) Y und X werden summiert (d.h. a+b=c:if C>256 then c=C-256). Die Zeichen werden bar erst ab der N+10ten Stelle entnommen.
// das ergibt den neuen Wert Z. Nun wird noch geprft, ob sich eine Periode aus geraden (5)
// oder ungeraden Zahlen (7) aufgebaut hat, wenn ja, wird zu z dewr Wert 1 addiert (Z=(z+1)mod 256).
//Buchstaben Z, der wird hinten an das Paword (ergibt den Masterstring) angehngt
//
//3) Dann goto 1). Man rckt aber die Position um ein Zeichen weiter, bildet wieder die Summe
// aus vier Zeichen und so weiter......
//4) Wenn die Zeichenkette viermal so lang wie der zu codierende String plus Codewort + 50 ist, bricht man ab.
//5) Vom vorderen Teil des Masterstrings wird das Paword und die ersten 30 Zeichen abgeschnitten.
// dieser Masterstring ist nun eine scheinbar chaotische, lange Zahlenfolge. Kennt man aber einen Teil des Masterstrings, knnte man unter Umstnden daraus aber noch den Rest konstruieren. Deshalb wird der nochmals weiterbearbeitet
//6)er wird zunchst mit der Prozedur Matrixwirbeln zerrissen
// dann wird dieser Masterstring wieder mit der obigen Prozedur schrittweise ausgelesen,
//dabei wird allerdsings nach jedem Auslesen um vier Ziffern weitergerckt.
// die Summe wird auch nur durch einfaches Addieren von abcd, ohne Zuzhlen von 1, erzeugt.
// Die so erhaltenen "Zufallsziffern" werden nun aneinandergereiht zum Codestring.
// Dieser ist nun eine "ziemlich echte" Pseudozufallszahlenfolge.

//7) Der zu codierende String wird nun Zeichen fr Zeichen zu dem Codestring addiert (d.H. 256 rotiert)
//
//Decodieren:
// Aus dem Paword wird der Codestring gebildet
// Damit wird der codierte String entschlsselt, dh. subtrahiert.
// Dann wird der Positionswechselalgorithmus umgekehrt.

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, Menus, Gauges, ExtCtrls;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Fortschritt: TGauge;
    Image1: TImage;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    Label5: TLabel;
    Label1: TLabel;
    Panel4: TPanel;
    Button1: TButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  quelltext: string;
  code:string;
  eingabecode: string;
  codiertertext: string;
  openfile, savefile: File; //untypisierte Dateivariablen
  buf               : Array [1..10111] of Char; //Dateipuffer(legt die Gre der
                      // Blcke fest, die nacheinander codiert werden.
  br, bw            : Integer; //br=BytesRead; bw=BytesWritten
  dg, ar            : Integer; //dg=Dateigroesse; ar=AbsolutlyRead


implementation

{$R *.DFM}

///codierroutinen (C.H.Wunderlich Mai/Juli/August 98)

procedure rechteckdimension (text:string;drehwert:longint;var hoehe:longint;var breite:longint;var rest: longint);
// diese Prozedur ermittelt die Dimensionen der Matrix
//im Gegensatz zu voherigen Versionen wird hier auch die matrixdimension variiert....
var laenge:longint;
var f: integer;
var folge:integer;
begin
  laenge:=length(text);
  hoehe:=trunc(sqrt(laenge));
  folge:=67;
  if (hoehe+1)<folge then folge:=hoehe;
  f:=(drehwert mod folge);
  hoehe:=trunc(hoehe-f);
    //damit wird also die Matrixgre je nach pawortzeichen verndert. Es gibt normalerweise ca. 67 verschieden Zeichen, deshalb diese willkrliche Wahl.
  if hoehe=0 then hoehe:=1;
  breite:=trunc(laenge/hoehe);
  rest:=laenge-hoehe*breite;

end;

//Diese Prozedur liest den Textstring in die Matrix ein und gibt ein Array von Spalten zurck
procedure ein_und_auslesen(text:string;hoehe,breite,rest:longint;var spalten:array of string);
var
  spaltenzaehler:longint;
  zeilenzaehler:longint;
begin

//loeschen der alten spalten

for spaltenzaehler:=1 to breite+1 do
begin
  spalten[spaltenzaehler]:='';
end;
//einlesen des Textes in die Matrix

for spaltenzaehler:=1 to breite do
begin
  for zeilenzaehler:=0 to (hoehe-1) do
    begin
      spalten[spaltenzaehler]:=spalten[spaltenzaehler]+copy(text,zeilenzaehler*breite+spaltenzaehler,1);
    end;
end;

for spaltenzaehler:=1 to rest do
begin
  spalten[spaltenzaehler]:=spalten[spaltenzaehler]+copy(text,(hoehe*breite+spaltenzaehler),1);
end;

end;


procedure re_ein_und_auslesen(hoehe,breite,rest:longint;spalten:array of string;var retext:string);
//diese prozedur ist die umkehrprozedur zu ein_und auslesen: spalten werden eingegeben, und der text zeilenweise ausgelesen.
var
  spaltenzaehler:longint;
  zeilenzaehler:longint;
begin

//loeschen der alten zeilen
retext:='';
//einlesen der spalten in zeilen
for zeilenzaehler:=0 to (hoehe-1) do
begin
for spaltenzaehler:=1 to breite do
begin
  retext:=retext+copy(spalten[spaltenzaehler],zeilenzaehler+1,1);
end;
end;

for spaltenzaehler:=1 to rest do
begin
  retext:=retext+copy(spalten[spaltenzaehler],(hoehe+1),1);
end;

end;

procedure spalten_drehen (spalten:array of string; betrag:longint;breite:longint;var gedrehte_spalten:array of string);
var n,spaltenlaenge,verschiebewert: longint;
begin
N:=0;
repeat
N:=n+1;
spaltenlaenge:=length(spalten[N]);
verschiebewert:= betrag mod spaltenlaenge;
if (N mod 2)=0 then
//wenn N gerade, dann wird nach rckwrts verschoben
gedrehte_spalten[N]:=copy(spalten[N],verschiebewert+1,spaltenlaenge-verschiebewert)+copy(spalten[n],1,verschiebewert);

if (N mod 2)=1 then
//wenn n ungerade, dann wird nach vorwaerts verschoben
gedrehte_spalten[N]:=copy(spalten[N],spaltenlaenge-verschiebewert+1,verschiebewert)+copy(spalten[N],1,spaltenlaenge-verschiebewert);
//if verschiebewert=0 then
//gedrehte_spalten[N]:=spalten[N];
until N=breite;
end;

procedure matrixwirbeln(eingabetext:string;codewort:string;var ausgabetext:string);
//diese Prozedur fhrt den positionswechsel aus
var hoehe,breite,rest:longint;
var n:longint;
var codezeichenzaehler, codewortlaenge:longint;
var drehwert:longint;
var drehwertzeichen:ansichar;

teile:array [0..10000]of string;
//die arrays mssen mit 0 beginnen, wenn ihnen ein freies array als parameter bergeben wird.Das ist so.
begin

codezeichenzaehler:=0;
codewortlaenge:=length(codewort);
//schleife: codewort zeichen fr zeichen abarbeiten
repeat
codezeichenzaehler:=codezeichenzaehler+1;
drehwertzeichen:=(codewort[codezeichenzaehler]);
drehwert:=ord(drehwertzeichen);
drehwert:=drehwert+1 ;//damit drehwert nicht 0 wird..
rechteckdimension (eingabetext,drehwert,hoehe,breite,rest);

ein_und_auslesen(eingabetext,hoehe,breite,rest,teile);
spalten_drehen(teile,drehwert,breite,teile);
ausgabetext:='';
//zusammenfgen der aus ein/auslesen erhaltenen spalten
for n:=1 to (breite) do
begin
ausgabetext:=ausgabetext+teile[n];
end;
// um wieder den verdrehten text rekursiv weiterbehandeln zu knnen)
eingabetext:=ausgabetext;
//nchstes codezeichen
until (codezeichenzaehler=codewortlaenge);
//
end;

procedure spalten_zurueck_drehen (spalten:array of string; betrag:longint;breite:longint; var gedrehte_spalten:array of string);
//dreht ein array von Spalten gegeneinander um einen betrag
var n,spaltenlaenge,verschiebewert: longint;
begin

N:=0;
repeat
N:=n+1;
spaltenlaenge:=length(spalten[N]);
verschiebewert:= betrag mod spaltenlaenge;

if (N mod 2)=1 then

//wenn N ungerade, dann wird nach rckwrts verschoben
gedrehte_spalten[N]:=copy(spalten[N],verschiebewert+1,spaltenlaenge-verschiebewert)+copy(spalten[n],1,verschiebewert);

if (N mod 2)=0 then
//wenn N gerade, dann wird nach vorwaerts verschoben
gedrehte_spalten[N]:=copy(spalten[N],spaltenlaenge-verschiebewert+1,verschiebewert)+copy(spalten[N],1,spaltenlaenge-verschiebewert);
// wenn verschiebewert =0 dann wird nicht gedreht
if verschiebewert=0 then
gedrehte_spalten[N]:=spalten[N];

until N=breite;
end;

procedure re_matrixwirbeln(eingabetext:string;codewort:string;var ausgabetext:string);
//diese prozedur wandelt die positionscodierte zeichenfolge wieder in normale zeichenfolge um
//erst teilen des textes in spalten, (zurckdrehen de spalten) bergabe der spalten an re_einundauslesen, bernahme der zeile von dort

var hoehe,breite,rest:integer;
var n,m:longint;
teile:array [0..10000]of string;
var codezeichenzaehler, codewortlaenge:longint;
var drehwert:longint;
var drehwertzeichen:ansichar;

//die arrays mssen mit 0 beginnen, wenn ihnen ein freies array als parameter bergeben wird.Das ist so.
//oder mu das mit 1 beginnen ? ich wei es nicht. ausprobieren !
begin

codewortlaenge:=length(codewort);
codezeichenzaehler:=codewortlaenge;

//schleife: codewort zeichen fr zeichen abarbeiten
repeat
drehwertzeichen:=(codewort[codezeichenzaehler]);
drehwert:=ord(drehwertzeichen);
drehwert:=drehwert+1; //damit drehwert nicht 0 wird..
rechteckdimension (eingabetext,drehwert,hoehe,breite,rest);


//Zerlegen der (verwirbelten) textkette in spalten

for n:=1 to rest do
begin
teile[n]:=copy(eingabetext,(n-1)*(hoehe+1)+1,(hoehe+1));
end;
for m:=(rest + 1) to breite do
begin
teile[m]:=copy(eingabetext,(rest*(hoehe+1))+(m-rest-1)*hoehe+1,hoehe);
end;

spalten_zurueck_drehen(teile,drehwert,breite,teile);


//aufruf der routine: einlesen der spalten in die Matrix und auslesen als zeile

Re_ein_und_auslesen(hoehe,breite,rest,teile,ausgabetext);

// um wieder den verdrehten text rekursiv weiterbehandeln zu knnen)
eingabetext:=ausgabetext;
//nchstes codezeichen
codezeichenzaehler:=codezeichenzaehler-1;

until (codezeichenzaehler=0);
//
end;

procedure einen_byte_anhaengen(zeichenkette:string;wert:integer;var zeichenketteplus:string);
//diese prozedur hngt an einen beliebigen string ein Zeichen mit dem ansiwert "wert" an
var kettenlaenge:longint;
begin
kettenlaenge:=length(zeichenkette);
zeichenkette:=zeichenkette+'*';
zeichenkette[kettenlaenge+1]:=chr(wert);
zeichenketteplus:=zeichenkette;
zeichenkette:='';
end;

procedure plusrot(a:integer;b:integer; var retour: integer);
//die prozedur rotiert einen wert a um betrag b um (0...255)
begin
retour:=a+b;
if retour>255 then retour:=retour-256;

end;

procedure minusrot(a:integer;b:integer; var retour: integer);
//wie plusrot, nur gegenrichtung..
begin
retour:=a-b;
if retour<0 then retour:=retour+256;

end;

procedure werte_ziehen_und_summieren(anzahl:integer;bis:longint;ausstring:string;var summe:integer);
// die prozedur zieht in gleichen abstnden "anzahl" zeichen aus einer Zeichenkette von 1 bis "bis" und "summiert" sie.
var n:integer;
var probestart:integer;
var probestelle:longint;
var abstand: longint;
begin
n:=0;
abstand:=trunc(bis/anzahl);
summe:=0;
probestart:=length(code)+10;
//die variable Probestart legt fest, ab wo Proben gezogen werden drfen.
repeat
probestelle:= n*abstand+1;
if probestelle>probestart then plusrot(summe,ord(ausstring[probestelle]),summe);
// weil natrlich aus dem codewort selber keine Probe gezogen werden darf..
n:=n+1;
until n=anzahl;

end;

procedure codestring_erzeugen(code:string;ziellaenge:longint;var codestring:string);
// diese Prozedur erzeugt den Codestring (String aus Zufallswerten)
var masterstringlaenge:longint;
codelaenge:integer;
n:longint;
astr,bstr,cstr,dstr:integer;
X:integer;
Y:integer;
Z:integer;
Abzuschneiden:integer;
masterstring:string;
geradezaehler:integer;
ungeradezaehler: integer;
codestringlaenge:longint;

begin
masterstring:=code;
codelaenge:=length(code);
masterstringlaenge:=length(masterstring);

if masterstringlaenge<6 then
begin
repeat
masterstring:=masterstring+masterstring;
masterstringlaenge:=masterstringlaenge*2;
until masterstringlaenge>6;
end;

//in dieser schleife werden nacheinander auf eine recht schlichte Weise aus dem Codewort
// Pseudozufallsziffern erzeugt und an den Masterstring angehngt
// der Masterstring wird mehr als viermal so lang wie der zu chiffrierende Textblock..
n:=1;
geradezaehler:=0;
ungeradezaehler:=0;

form1.Fortschritt.forecolor:=clRed;

repeat
astr:=ord(masterstring[n]);
bstr:=ord(masterstring[n+1]);
cstr:=ord(masterstring[n+2]);
dstr:=ord(masterstring[n+3]);

x:=astr+bstr+cstr+dstr+1;
x:=x mod 256;

werte_ziehen_und_summieren(codelaenge,masterstringlaenge,masterstring,y);
plusrot(x,y,z);

// hier wird geprft, ob sich evtl. Perioden aufbauen
if trunc(z/2)=z/2 then
begin
geradezaehler:=geradezaehler+1;
ungeradezaehler:=0;
end;

if trunc(z/2)<>z/2 then
begin
ungeradezaehler:=ungeradezaehler+1;
geradezaehler:=0;
end;
//
if geradezaehler>5 then
begin
z:=(z+1)mod 256;
geradezaehler:=0;
end;

if ungeradezaehler>7 then
begin
z:=(z+1)mod 256;
ungeradezaehler:=0;
end;

einen_byte_anhaengen(masterstring,z,masterstring);

n:=n+1;
masterstringlaenge:=masterstringlaenge+1;

//das ist nur ein bischen Spielerei in der Anzeige:
if masterstringlaenge=ziellaenge then form1.Fortschritt.forecolor:=clMaroon;
if masterstringlaenge=ziellaenge*2 then form1.Fortschritt.forecolor:=clRed;
if masterstringlaenge=ziellaenge*3 then form1.Fortschritt.forecolor:=clMaroon;

until masterstringlaenge>(ziellaenge*4)+codelaenge+50;

//nun mu nur noch der anfang abggeschnitten werden
abzuschneiden:=codelaenge+30;
masterstring:=copy(masterstring,abzuschneiden+1,length(masterstring)-abzuschneiden);
// und nun ist er fertig, der masterstring.

// jetzt mu der masterstring verndert werden, damit nicht bei codestringerzeugen das gleiche herauskommt....
// dazu wird einfach die Routine Matrixwirbeln verwendet.
form1.Fortschritt.forecolor:=clGray;
matrixwirbeln (masterstring,code,masterstring);
//an der Stelle kann man brigens sehr schn den gesamten algo verndern, indem man statt nur mit dem code noch an den Code was anhngt.
//nun mu daraus der Codestring gebildet werden.

codestring:='';
form1.Fortschritt.forecolor:=clSilver;
//in dieser schleife werden nacheinander zufallsziffern aus dem Masterstring erzeugt und an den Codestring angehngt
n:=1;
codestringlaenge:=0;
repeat

astr:=ord(masterstring[n]);
bstr:=ord(masterstring[n+1]);
cstr:=ord(masterstring[n+2]);
dstr:=ord(masterstring[n+3]);

x:=astr+bstr+cstr+dstr;
x:=x mod 256;

//probeziehen hier nicht nochmal ntig, weil der masterstring ja schon "zufllig" ist.
einen_byte_anhaengen(codestring,x,codestring);

n:=n+4;
//es wird also immer in 4er-Blocks weitergesprungen....
codestringlaenge:=codestringlaenge+1;
until codestringlaenge>ziellaenge+1;

//nun ist der codestring fertig.

end;

procedure codestring_addieren (codestring:string;eingabetext:string;var ausgabetext:string);
//diese prozedur addiert den codestring (zum verschlsseln)
var N:longint;
ziel:longint;
a:integer;
begin
N:=0;
ziel:=length(eingabetext);
ausgabetext:='';
repeat
N:=N+1;
ausgabetext:=ausgabetext+'*';
plusrot(ord(eingabetext[n]),ord(codestring[n]),a);
ausgabetext[n]:=chr(a);
until N=ziel;
end;


procedure codestring_subtrahieren (codestring:string;eingabetext:string;var ausgabetext:string);
//die prozedur subtrahiert den Codestring (zum entschlsseln)
var N:longint;
ziel:longint;
a:integer;
begin
N:=0;
ausgabetext:='';
ziel:=length(eingabetext);
repeat
N:=N+1;
ausgabetext:=ausgabetext+'*';
minusrot(ord(eingabetext[n]),ord(codestring[n]),a);
ausgabetext[n]:=chr(a);
until N=ziel;
end;


// nachfolgend die eigentlichen I/O-Routines  (Michael Krieg)


procedure TForm1.SpeedButton1Click(Sender: TObject);
//datei codieren hauptroutine
var codestring       : string;
i                    : integer;
hs                   : string;
blockzaehler         : integer;


begin
  form1.OpenDialog1.title:='datei zum verschlsseln auswhlen..';
  form1.saveDialog1.title:='verschlsselte datei speichern in..';
  if OpenDialog1.Execute then                        { Dateidialog ffnen }
  begin
    eingabecode := form1.edit1.text;
    if eingabecode=''
      then eingabecode:='a';
    AssignFile(OpenFile, OpenDialog1.FileName);
    Reset(OpenFile, 1);
    dg := FileSize(OpenFile);
    ar := 0;
    if SaveDialog1.Execute then                              { Speichern-Dialog ffnen}
    begin
      if fileexists (savedialog1.FileName)
        then if messagedlg('Datei dieses Namens existiert schon. berschreiben?', mtWarning, [mbYes, mbNo],0) = mrNo
        then exit;
      with fortschritt do
        begin
          visible := True;
          Progress := 0;
        end;
      Screen.Cursor := crHourGlass;
      AssignFile(SaveFile, SaveDialog1.FileName);	{ Ausgabedatei ffnen }
      Rewrite(SaveFile, 1);
      blockzaehler:=0;
      repeat
        // aus datei lesen in buf
        fillchar (buf, sizeof(buf), ' ');
        BlockRead(OpenFile, Buf, SizeOf(Buf), br);
        ar := ar + br;
        //an das Pawort wird der Blockzaehler gehngt
        blockzaehler:=blockzaehler+1;
        Code:=eingabecode+floattostr(blockzaehler);
        //
        fortschritt.Progress := Trunc((ar * 100) / dg);
        if br > 0
          then begin
          // buf codieren
          hs := '';
          for i := 1 to br do
            hs := hs + buf [i];
          quelltext:=hs;
          form1.Fortschritt.forecolor:=clBlack;
          matrixwirbeln (quelltext,code,codiertertext);
          codestring:='';
          codestring_erzeugen(code,length(codiertertext),codestring);
          codestring_addieren(codestring,codiertertext,codiertertext);
          hs:=codiertertext;
          //nur kontrolle (anzeige)
          form1.panel2.caption:=quelltext;
          form1.panel3.caption:=codiertertext;
          //kontrolle Ende
          fillchar (buf, sizeof(buf), ' ');
          for i := 1 to br do
            buf [i] := hs [i];
          // buf codiert zurckschreiben
          BlockWrite(SaveFile, Buf, br, bw);
        end;
        Application.ProcessMessages;
      until (br = 0) or (bw <> br);
      CloseFile(OpenFile);
      CloseFile(SaveFile);
      Screen.Cursor := crDefault;
      Showmessage ('verschlsselung beendet!');
      Fortschritt.Visible := False;

    end;
  end;

end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
//datei decodieren hauptroutine
var subtrahierter_codiertertext, codestring:string;
i                    : integer;
hs                   : string;
blockzaehler         : integer;
begin
  form1.OpenDialog1.title:='datei zum decodieren auswhlen..';
  form1.saveDialog1.title:='decodierte Datei speichern in..';
  if OpenDialog1.Execute then
  begin
    eingabecode := form1.edit1.text;
      if eingabecode=''
      then eingabecode:='a';
    AssignFile(OpenFile, OpenDialog1.FileName);
    Reset(OpenFile, 1);
    dg := FileSize(OpenFile);
    ar := 0;
    if SaveDialog1.Execute then
    begin
    if fileexists (savedialog1.FileName)
        then if messagedlg('Datei dieses Namens existiert schon. berschreiben?', mtWarning, [mbYes, mbNo],0) = mrNo
        then exit;
      with fortschritt do
        begin
          visible := True;
          Progress := 0;
                  end;
      AssignFile(SaveFile, SaveDialog1.FileName);
      Rewrite(SaveFile, 1);
      blockzaehler:=0;
      repeat
        // aus datei lesen in buf
        fillchar (buf, sizeof(buf), ' ');
        BlockRead(OpenFile, Buf, SizeOf(Buf), br);
        blockzaehler:=blockzaehler+1;
        //an das Pawort den blockzaehler anhngen
        code:=eingabecode+floattostr(blockzaehler);
        //
        ar := ar + br;
        fortschritt.Progress := Trunc((ar * 100) / dg);
        if br > 0
          then begin
          // buf decodieren
          hs := '';

          for i := 1 to br do
            hs := hs + buf [i];
          codiertertext:=hs;
          codestring_erzeugen(code,length(codiertertext),codestring);
          codestring_subtrahieren(codestring,codiertertext,subtrahierter_codiertertext);
          quelltext:='';
          form1.Fortschritt.forecolor:=clBlack;
          re_matrixwirbeln (subtrahierter_codiertertext,code,quelltext);
          hs:=quelltext;
          //nur kontrolle (anzeige)
          form1.panel2.caption:=quelltext;
          form1.panel3.caption:=codiertertext;
          //kontrolle Ende
          fillchar (buf, sizeof(buf), ' ');
          for i := 1 to br do
            buf [i] := hs [i];
          // buf codiert zurckschreiben
          BlockWrite(SaveFile, Buf, br, bw);
        end;
        Application.ProcessMessages;
      until (br = 0) or (bw <> br);
      CloseFile(OpenFile);
      CloseFile(SaveFile);
      Screen.Cursor := crDefault;
      Showmessage ('entschlsselung beendet');
      Fortschritt.Visible := False;

    end;
  end;


end;

// Menue Beenden


// Application initialisieren....
procedure TForm1.FormCreate(Sender: TObject);
begin
  fortschritt.Visible := False;
end;


procedure TForm1.Image1Click(Sender: TObject);
begin
form1.panel4.visible:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
form1.panel4.visible:=false;
end;

end.
